clear all
close all
clc

%1996Q1 - 2008Q4 = 1996.25 - 2009.00
t = 1996:1/4:2009;
t = t(2:end)';

x = load('Data.txt');
y = x(:,1);

%hdp sezonne ocistena
[y_SA SA_y] = dseasq(y);

%vypocet gapu pomoci hp filtru - pocitam z cele rady at je to lepsi
ly = log(y_SA);
[ly_trend ly_gap] = hpfilter(ly,1600);

%zkraceni
ly = ly(2:end);
ly_trend =  ly_trend(2:end);
ly_gap = ly_gap(2:end)*100;
t = t(2:end);

%nacteni vysledku odhadu
load DSGE1A_results
gap = oo_.PosteriorSmoothedVariables.Mean.gap;
gap_inf = oo_.PosteriorSmoothedVariables.HPDinf.gap;
gap_sup = oo_.PosteriorSmoothedVariables.HPDsup.gap;

yp = oo_.PosteriorSmoothedVariables.Mean.y_f;
yp_inf = oo_.PosteriorSmoothedVariables.HPDinf.y_f;
yp_sup = oo_.PosteriorSmoothedVariables.HPDsup.y_f;

y = oo_.PosteriorSmoothedVariables.Mean.y;
y_inf = oo_.PosteriorSmoothedVariables.HPDinf.y;
y_sup = oo_.PosteriorSmoothedVariables.HPDsup.y;


load DSGE1C_results
gapM = oo_.PosteriorSmoothedVariables.Mean.gap;
gapM_inf = oo_.PosteriorSmoothedVariables.HPDinf.gap;
gapM_sup = oo_.PosteriorSmoothedVariables.HPDsup.gap;
% gapM = [gapM;NaN];
% gapM_inf = [gapM_inf;NaN];
% gapM_sup = [gapM_sup;NaN];

ypM = oo_.PosteriorSmoothedVariables.Mean.y_f;
ypM_inf = oo_.PosteriorSmoothedVariables.HPDinf.y_f;
ypM_sup = oo_.PosteriorSmoothedVariables.HPDsup.y_f;
% ypM = [ypM;NaN];
% ypM_inf = [ypM_inf;NaN];
% ypM_sup = [ypM_sup;NaN];

yM = oo_.PosteriorSmoothedVariables.Mean.y;
yM_inf = oo_.PosteriorSmoothedVariables.HPDinf.y;
yM_sup = oo_.PosteriorSmoothedVariables.HPDsup.y;
% yM = [yM;NaN];
% yM_inf = [yM_inf;NaN];
% yM_sup = [yM_sup;NaN];

%nulovy vektor
n = length(gap);
z = zeros(n,1);

figure
plot(t, gap,'r-',t, gapM, 'm-',t,ly_gap,'g-', t,gap_inf,'r:', t, gap_sup,'r:',t,gapM_inf,'m:', t, gapM_sup,'m:',t,z,'k-');
grid;
title('DSGE gap a interval spolehlivosti')
legend('DSGE - tau 1,5','DSGE - tau 1,1','HP')

figure
plot(t, gap, 'b-',t,ly_gap,'g-',t,y,'r-',t,yp,'m-',t,z,'k-');
grid;
legend('GAP','HP','Y','YP')

figure
plot(t, y, 'b-',t, yM, 'r-',t,ly_gap,'g-',t,y_inf,'b:', t, y_sup,'b:',t,yM_inf,'r:', t, yM_sup,'r:',t,z,'k-');
grid;
legend('Y - tau 1,5','Y - tau 1,1','HP')

figure
plot(t, yp, 'b-',t, ypM, 'r-',t,ly_gap,'g-',t,yp_inf,'b:', t, yp_sup,'b:',t,ypM_inf,'r:', t, ypM_sup,'r:',t,z,'k-');
grid;
legend('YP - tau 1,5','YP - tau 1,1','HP')
