function [signal,noise] = hpfilter(x,lambda)

[m,n] = size(x);
if m < n
  x = x';   
  m = n;
end

a(1) = lambda+1;
a(2) = 5*lambda+1;
a(3:m-2) = 6*lambda+1;
a(m-1) = 5*lambda+1;
a(m) = lambda+1;
b(1) = -2*lambda;
b(2:m-2) = -4*lambda;
b(m-1) = -2*lambda;
c(1:m-2) = lambda;

signal = penta2(x,a,b,c);
noise = x-signal;

return

function x = penta2(y,a,b,c)

n = length(a);
m = length(y);
o = length(b);
p = length(c);

c(m) = 0;
c(m-1) = 0;
b(m) = 0;  

h1 = 0;
h2 = 0;
h3 = 0;
h4 = 0;
h5 = 0;
hh1 = 0;
hh2 = 0;
hh3 = 0;
hh4 = 0;
hh5 = 0;
z = 0;
hb = 0;
hc = 0;

for i = 1:m
  z = a(i)-h4*h1-hh5*hh2;
  hb = b(i);
  hh1 = h1;
  h1 = (hb-h4*h2)/z;
  b(i) = h1;
  hc = c(i);
  hh2 = h2;
  h2 = hc/z;
  c(i) = h2;
  a(i) = (y(i)-hh3*hh5-h3*h4)/z;
  hh3 = h3;
  h3 = a(i);
  h4 = hb-h5*hh1;
  hh5 = h5;
  h5 = hc;
end

h2 = 0;
h1 = a(m);
y(m) = h1;

for i = m:-1:1
  y(i) = a(i)-b(i)*h1-c(i)*h2;
  h2 = h1;
  h1 = y(i);
end

x = y;

return